---
title: XMLHttpRequest()
slug: Web/API/XMLHttpRequest/XMLHttpRequest
tags:
  - API
  - Constructor
  - Creating an XMLHttpRequest
  - Fetching Data
  - Loading Data
  - NeedsBrowserCompatibility
  - NeedsExample
  - NeedsSpecTable
  - Reading Data
  - Reference
  - Server Access
  - XHR
  - XMLHttpRequest
---
<div>{{draft}}{{APIRef('XMLHttpRequest')}}</div>

<p><span class="seoSummary">The <code><strong>XMLHttpRequest()</strong></code> constructor creates a new {{domxref("XMLHttpRequest")}}.</span></p>

<p>For details about how to use <code>XMLHttpRequest</code>, see <a class="internal" href="/en-US/docs/Web/API/XMLHttpRequest/Using_XMLHttpRequest">Using XMLHttpRequest</a>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">const <var>request</var> = new XMLHttpRequest();
</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p>A new {{domxref("XMLHttpRequest")}} object. The object must be prepared by at least calling {{domxref("XMLHttpRequest.open", "open()")}} to initialize it before calling {{domxref("XMLHttpRequest.send", "send()")}} to send the request to the server.</p>

<h2 id="Non-standard_Firefox_syntax">Non-standard Firefox syntax</h2>

<p>Firefox 16 added a non-standard parameter to the constructor that can enable anonymous mode (see {{Bug("692677")}}). Setting the <code>mozAnon</code> flag to <code>true</code> effectively resembles the <a href="http://www.w3.org/TR/2012/WD-XMLHttpRequest-20120117/#dom-anonxmlhttprequest" title="see AnonXMLHttpRequest in the XMLHttpRequest specification"><code>AnonXMLHttpRequest()</code></a> constructor described in older versions of the XMLHttpRequest specification.</p>

<pre class="syntaxbox">const <var>request</var> = new XMLHttpRequest(<var>paramsDictionary</var>);</pre>

<h3 id="Parameters_(non-standard)">Parameters (non-standard)</h3>

<dl>
 <dt><code>objParameters</code> {{gecko_minversion_inline("16.0")}}</dt>
 <dd>There are two flags you can set:
 <dl>
  <dt><code>mozAnon</code></dt>
  <dd>Boolean: Setting this flag to <code>true</code> will cause the browser not to expose the {{Glossary("origin")}} and <a href="http://www.w3.org/TR/2012/WD-XMLHttpRequest-20120117/#user-credentials" title="Defintion of “User credentials” in the XMLHttpRequest specification.">user credentials</a> when fetching resources. Most important, this means that {{Glossary("Cookie", "cookies")}} will not be sent unless explicitly added using setRequestHeader.</dd>
  <dt><code>mozSystem</code></dt>
  <dd>Boolean: Setting this flag to <code>true</code> allows making cross-site connections without requiring the server to opt-in using {{Glossary("CORS")}}. <em>Requires setting <code>mozAnon: true</code>, i.e. this can't be combined with sending cookies or other user credentials. This only works in privileged (reviewed) apps ({{Bug("692677")}}); it does not work on arbitrary webpages loaded in Firefox</em></dd>
 </dl>
 </dd>
</dl>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/XMLHttpRequest/Using_XMLHttpRequest">Using XMLHttpRequest</a></li>
 <li><a href="/en-US/docs/Web/API/XMLHttpRequest/HTML_in_XMLHttpRequest">HTML in XMLHttpRequest</a></li>
</ul>
